// item.cpp
// ackmed@gotwalls.com
#include "item.h"
#include "shopbot.h"
#include "MagicPrefix.h"
#include "MagicSuffix.h"

ITEMSTRUCT *ParseItemDrop(BYTE *Packet, DWORD Length) {
	ITEMSTRUCT *item = new ITEMSTRUCT;

	BitFields iPacket(Packet,Length);	

	item->MessageID = iPacket.GetField(8);

	if(item->MessageID != ITEM_MESSAGEID_DROP) {
		delete item;
		return NULL;
	}
	
	item->Action = iPacket.GetField(8);
	if(item->Action != ITEM_ACTION_TO_STORE) {
		delete item;
		return NULL;
	}

	item->MessageSize = iPacket.GetField(8);
	item->ItemType = iPacket.GetField(8);

	// only care about weapons.  need to also add bows
	if(item->ItemType != ITEM_ITEMTYPE_WEAPON) {
		delete item;
		return NULL;
	}
	item->ItemID = iPacket.GetField(32);

	// flags
	item->isSocketsFull = iPacket.GetField(1);
	DebugItemBits(iPacket.GetField(3),3,iPacket.pos);
	item->isIdentified = iPacket.GetField(1);
	DebugItemBits(iPacket.GetField(1),1,iPacket.pos);
	item->isSwitchin = iPacket.GetField(1);
	item->isSwitchout = iPacket.GetField(1);
	item->isBroken = iPacket.GetField(1);
	DebugItemBits(iPacket.GetField(1),1,iPacket.pos);
	item->fromBelt = iPacket.GetField(1);
	item->hasSockets = iPacket.GetField(1);
	DebugItemBits(iPacket.GetField(1),1,iPacket.pos);
	item->isJustGenerated = iPacket.GetField(1);
	DebugItemBits(iPacket.GetField(2),2,iPacket.pos);
	item->isEar = iPacket.GetField(1);
	item->isStartitem = iPacket.GetField(1);
	DebugItemBits(iPacket.GetField(3),3,iPacket.pos);
	item->isMiscItem = iPacket.GetField(1);
	item->isEthereal = iPacket.GetField(1);
	DebugItemBits(iPacket.GetField(1),1,iPacket.pos);
	item->isPersonalized = iPacket.GetField(1);
	item->isGamble = iPacket.GetField(1);
	item->isRuneWord = iPacket.GetField(1);
	
	DebugItemBits(iPacket.GetField(5),5,iPacket.pos);
	item->MPQVersionField = iPacket.GetField(10);
	
	item->Location = iPacket.GetField(3);
	iPacket.GetField(4);
	item->PositionX = iPacket.GetField(4);
	item->PositionY = iPacket.GetField(4);
	iPacket.GetField(3);

	// is ear?  not exactly possible  
	if(item->isEar) {
		delete item;
		return NULL;
	}

	if(!item->isIdentified) {
		if(Debug == DEBUG_DEVEL) {
			server->GamePrintString("Item was unidentified");
		}
		delete item;
		return NULL;
	}
	// read in itemcode, its a string;
	item->ItemCode[0] = iPacket.GetField(8);
	item->ItemCode[1] = iPacket.GetField(8);
	item->ItemCode[2] = iPacket.GetField(8);
	item->ItemCode[3] = iPacket.GetField(8);

	// chomp off the space if it exists
	if(item->ItemCode[3] == ' ') {
		item->ItemCode[3] = '\0';
	} else {
		item->ItemCode[4] = '\0';
	}

	DebugItemBits(iPacket.GetField(8),8,iPacket.pos);
	DebugItemBits(iPacket.GetField(2),2,iPacket.pos);
	item->ItemLevel = iPacket.GetField(4);

	// only care about magic items.
	if(item->ItemLevel == ITEM_LEVEL_MAGIC) {
		iPacket.GetField(2);
		WORD row;
		
		row = iPacket.GetField(11);	 // prefix
		if(row > 0) {
			item->MagicPrefix = GetMagicPrefixRowNumber(row);
			if(item->MagicPrefix != NULL) {
				if(item->MagicPrefix->Prefix == NULL) {
					item->MagicPrefix = NULL;
				}
			}
		} else {
			item->MagicPrefix = NULL;
		}

		row = iPacket.GetField(11);	 // sugfix
		if(row > 0) {
			item->MagicSuffix = GetMagicSuffixRowNumber(row);
			if(item->MagicSuffix != NULL) {
				if(item->MagicSuffix->Suffix == NULL) {
					item->MagicSuffix = NULL;
				}
			}
		} else {
			item->MagicSuffix = NULL;
		}

		
		return item;
	} else {
		delete item;
		return NULL;
	}
}

void DumpItemStruct(ITEMSTRUCT *item) {

	char DumpString[1024];
	
	BOOL found = false;
	
	sprintf(DumpString,"%s","DumpItemStruct ");
	
	if(item->MagicPrefix != NULL) {
		sprintf(DumpString,"%s (%s)",DumpString,item->MagicPrefix->Prefix);
	}

	sprintf(DumpString,"%s %s",DumpString,item->ItemCode);

	if(item->MagicSuffix != NULL) {
		sprintf(DumpString,"%s (%s)",DumpString,item->MagicSuffix->Suffix);
	}
	
	
	server->GamePrintString(DumpString);
	return;
	// stuff that isnt useful for normal users
	if(Debug) {
		sprintf(DumpString,"%s Action:",DumpString);
		switch(item->Action) {
			case ITEM_ACTION_NEW_GROUND:
				sprintf(DumpString,"%s new ground",DumpString);
				break;
			case ITEM_ACTION_OLD_GROUND:
				sprintf(DumpString,"%s old ground",DumpString);
				break;
			case ITEM_ACTION_DROP:
				sprintf(DumpString,"%s drop",DumpString);
				break;
			default:	// should never get here
				sprintf(DumpString,"%s ?%.x",DumpString,item->Action);
				break;
		}

		sprintf(DumpString,"%s Loc: (%d,%d)",DumpString,item->PositionX,item->PositionY);
		sprintf(DumpString,"%s ItemID: %d",DumpString,item->ItemID);
		sprintf(DumpString,"%s MPQ: %d",DumpString,item->MPQVersionField);
		sprintf(DumpString,"%s Flags: ",DumpString);
		
		if(item->fromBelt) 
			sprintf(DumpString,"%s fromBelt",DumpString);
		if(item->isBroken) 
			sprintf(DumpString,"%s isBroken",DumpString);
		if(item->isEar) 
			sprintf(DumpString,"%s isEar",DumpString);
		if(item->isGamble) 
			sprintf(DumpString,"%s isGamble",DumpString);
		if(item->isJustGenerated) 
			sprintf(DumpString,"%s isJustGenerated",DumpString);
		if(item->isMagicExtra) 
			sprintf(DumpString,"%s isMagicExtra",DumpString);
		if(item->isMiscItem) 
			sprintf(DumpString,"%s isMiscItem",DumpString);
		if(item->isPersonalized) 
			sprintf(DumpString,"%s isPersonalize",DumpString);
		if(item->isRuneWord) 
			sprintf(DumpString,"%s isRuneWord",DumpString);
		if(item->isStartitem) 
			sprintf(DumpString,"%s isStartItem",DumpString);
		if(item->isSwitchin) 
			sprintf(DumpString,"%s isSwitchin",DumpString);
		if(item->isSwitchout) 
			sprintf(DumpString,"%s isSwitchout",DumpString);

	}

	sprintf(DumpString,"%s ItemType: ",DumpString);
	switch(item->ItemType) {
		case ITEM_ITEMTYPE_HELM:
			sprintf(DumpString,"%s helm",DumpString);
			break;
		case ITEM_ITEMTYPE_ARMOR:
			sprintf(DumpString,"%s armor",DumpString);
			break;
		case ITEM_ITEMTYPE_WEAPON:
			sprintf(DumpString,"%s weapon",DumpString);
			break;
		case ITEM_ITEMTYPE_BOW:
			sprintf(DumpString,"%s bow",DumpString);
			break;
		case ITEM_ITEMTYPE_SHIELD:
			sprintf(DumpString,"%s shield",DumpString);
			break;
		case ITEM_ITEMTYPE_EXPANSION:
			sprintf(DumpString,"%s expansion",DumpString);
			break;
		case ITEM_ITEMTYPE_OTHER:
			sprintf(DumpString,"%s other",DumpString);
			break;
		default:
			sprintf(DumpString,"%s ?%.2x",DumpString,item->ItemType);
			break;
	}

	// need to stop if isEar is set
	if(item->isEar) {
		sprintf(DumpString,"%s isEar",DumpString);
		server->GamePrintString(DumpString);
		return;
	}

	sprintf(DumpString,"%s ItemCode: \"%s\"",DumpString,item->ItemCode);
	
	if(item->ItemLevel != ITEM_UNSET) {
		sprintf(DumpString,"%s ItemLevel:",DumpString);
		switch(item->ItemLevel) {
			case ITEM_LEVEL_INFERIOR:
				sprintf(DumpString,"%s inferior",DumpString);
				break;
			case ITEM_LEVEL_NORMAL:
				sprintf(DumpString,"%s normal",DumpString);
				break;
			case ITEM_LEVEL_SUPERIOR:
				sprintf(DumpString,"%s superior",DumpString);
				break;
			case ITEM_LEVEL_MAGIC:
				sprintf(DumpString,"%s magic",DumpString);
				break;
			case ITEM_LEVEL_SET:
				sprintf(DumpString,"%s set",DumpString);
				break;
			case ITEM_LEVEL_RARE:
				sprintf(DumpString,"%s rare",DumpString);
				break;
			case ITEM_LEVEL_UNIQUE:
				sprintf(DumpString,"%s unique",DumpString);
				break;
			case ITEM_LEVEL_CRAFT:
				sprintf(DumpString,"%s craft",DumpString);
				break;
			default:
				sprintf(DumpString,"%s ?%.2x",DumpString,item->ItemLevel);
				break;
		}
	}
	sprintf(DumpString,"%s Flags:",DumpString);
	if(item->hasSockets) 
		sprintf(DumpString,"%s hasSockets",DumpString);
	if(item->isEthereal) 
		sprintf(DumpString,"%s isEthereal",DumpString);
	if(item->isSocketsFull) 
		sprintf(DumpString,"%s isSocketsFull",DumpString);
	if(item->isIdentified) {
		sprintf(DumpString,"%s isIdentified",DumpString);
	} else {
		sprintf(DumpString,"%s isUnidentified",DumpString);
	}
	
	sprintf(DumpString,"%s Prefix: %d Suffix: %d",DumpString,item->MagicPrefix,item->MagicSuffix);
	server->GamePrintString(DumpString);
	
}	

void DebugItemBits(BYTE data, BYTE size, DWORD pos) {
// fill me in!
	BYTE n;

	if(Debug == DEBUG_PACKET) {
		sprintf(DebugBuffer,"%d: ",pos);
		if(size > 8)
			size = 8;

		if(size != 8) {
			data = data<<(8 - size);
			
		}
		for(n = 0;n < size;n++) {
			if((data & 0x80) !=0)
			{
				sprintf(DebugBuffer,"%s1",DebugBuffer);
			}
			else
			{
				sprintf(DebugBuffer,"%s0",DebugBuffer);
			}
			data = data<<1;
		}
		server->GamePrintInfo(DebugBuffer);
	}
}
// from mousepad with some small mods
DWORD GetBitField(BYTE* data, DWORD pos, DWORD len, DWORD max) {
	// trying to read beyond the end of the packet

	if(pos + len > max) {

		// if we are already at or beyond the end of packet, return 0;
		if(pos >= max) {
			return 0;
		}
		// otherwise adjust len to all remaining bits
		if(Debug == DEBUG_PACKET) {
			sprintf(DebugBuffer,"Trying to read beyond eop. len:%d pos:%d max:%d",len,pos,max);
			server->GamePrintString(DebugBuffer);
		}
		len = max - pos;
	}

	return (DWORD)(*(unsigned __int64 *)(data+pos/8)<<(64-len-(pos&7))>>(64-len));
}